Apache2 default site contains only the words "It works!"

Bug #89364 reported by Noah Slater
10
Affects Status Importance Assigned to Milestone
apache2 (Ubuntu)
Fix Released
Medium
Soren Hansen

Bug Description

Binary package hint: apache

The default apache index page is installed in the current location:

/var/www/apache2-default/index.html

On my system the content of this file is:

<html><body><h1>It works!</h1></body></html>

Also, this file has no trailing newline which is malformed.

The default apache site should be informative with pointers to documentation, not a childish one line statement such as this. It looks highly unprofessional.

Revision history for this message
Vassilis Pandis (pandisv) wrote :

Confirmed on Feisty.

Changed in apache:
importance: Undecided → Medium
status: Unconfirmed → Confirmed
Revision history for this message
William Grant (wgrant) wrote :

The bug is in apache2, not apache.

Revision history for this message
Soren Hansen (soren) wrote :

I asked around, and it turns out that back in the ol' days when that page actually contained useful information, it was often left there only to be found by random passers by, who in turn contacted either the apache developers or the Debian apache maintainers bugging them about things that didn't work, etc. I rather consider the removal a sound decision and will hence reject this bug.

Thanks for your bug report.

Changed in apache2:
assignee: nobody → shawarma
status: Confirmed → Rejected
Revision history for this message
Noah Slater (nslater) wrote :

I appreciate this - but can we choose something more professional than "It works."

There are plenty of things that it could say without giving the contact details of Ubuntu, Debian or Apache.

Revision history for this message
Noah Slater (nslater) wrote :
Changed in apache2:
status: Rejected → Unconfirmed
Revision history for this message
Noah Slater (nslater) wrote :

I have reopened this bug as:

 1) The file is still malformed without a newline.
 2) I think the message should be change to something a little less terse or a 404 error.

Changed in apache2:
status: Unconfirmed → Confirmed
Revision history for this message
Owen (owen-boyle) wrote :

Noah,

What usually happens is that an ISP sets up a site for a client and loads the default docs. They then tell the client that their site is available. The client goes to their site and sees the apache logo and assumes that ASF has hijacked their site. I was around the last time an irate but technically inept web-user decided Apache had "stolen" his website and it was not pleasant - he spammed the lists for weeks until we had to get his ISP to unplug him...

Before proceeding further, I would urge you to do two things:

1) Search in the mailing list archives for the previous (and lengthy) discussions that took place on this very issue a few years ago (get the date when the page was changed to the current terse version from CVS and then search back from then in the archives). Read the thread and then reflect if this is still a good idea.

2) If you still think it's necessary to change it, compose a text that you'd like to see. It will have to avoid the pitfall that inexperienced web users will think that the ASF has "hijacked" their website. BTW, note that said users cannot be assumed to understand, or even read, anything that appears on the page. Oh, and you'll need it in all supported languages, too.

Revision history for this message
Noah Slater (nslater) wrote :

I understand everything you are saying. There is a simple solution, return a 404 Not Found. This message is already internationalised.

Revision history for this message
Soren Hansen (soren) wrote : Re: [Bug 89364] Re: Apache2 default site contains only the words "It works!"

On Mon, Jun 11, 2007 at 07:18:40AM -0000, Noah Slater wrote:
> I understand everything you are saying. There is a simple solution,
> return a 404 Not Found. This message is already internationalised.

Now, if every browser handled that properly, it would be a good idea.
Last time I checked, certain browsers (*cough* IE *cough*) treated a 404
very ungracefully. Essentially, you couldn't really tell the difference
between a webserver that did not respond at all and a standard 404. That
is going to lead to a bunch of bug reports and irate users as well.

Revision history for this message
Noah Slater (nslater) wrote :

Um, I think you must be mistaken. Every browser DOES handle that correctly.

Every version of IE that I have used displays a 404 Not Found message. Can you cite anything to support your claims?

If this is still not an option, how about the following text:

<h1>Your website has not been configured yet.</h1>

<p>Contact the site administrator who will tell you how to start adding content to your website.</p>

Revision history for this message
Owen (owen-boyle) wrote :

IN IE, go to Tools, Internet Options, Advanced then check "show friendly HTTP error messages". Then go to http://httpd.apache.org/wibble and you will see a client-generated page (ie, not the error_404.html page from apache). This is a well-known feature of IE and I'm a little uneasy that you're not aware of it...

Did you do the research I suggested above? You will find many of these issues have already been discussed..

Revision history for this message
Noah Slater (nslater) wrote :

You're uneasy that I am not aware of it? What a strange comment to make.

I am perfectly aware of this behaviour and it was this that I was suggesting Apache should make use of.

You have not provided any URIs to confirm that discussed took place. The Apache website provides no method of searching and Google provides me with no joy.

Can you provide me with a link to the specific thread you are referencing or tell me why my suggested text is unsuitable?

Revision history for this message
Owen (owen-boyle) wrote :

Hi Noah,

Did you try the thing I suggested to get IE to show its "friendly" error messages? The trouble is that it's possible to run a configuration of IE that does not display the 404 sent from the server. That's what Soren is talking about... Your response to his message implied you were unaware of this.

As regards finding th thread; you're the one proposing the change so please don't be offended if I invite you to do the leg-work :-) FWIW, I already spent about 20 minutes searching MARC but couldn't hit on a sufficiently accurate keyword. I already suggested you check the revision history to narrow down the date.

Maybe someone else can remember the kerfuffle?

Revision history for this message
Owen (owen-boyle) wrote :

Follow-up: Have a look at http://www.apache.org/foundation/preFAQ.html#itworked points 1, 2, 4 and 5. This was written to try to mitigate the questions that ASF was getting on this subject.

Revision history for this message
Loye Young (loyeyoung) wrote :

Apache.org recommends a more useful text that solves this bug and also gives appropriate guidance to users. The link Owen provided says it perfectly:

--Begin quote--
If you have sent us mail because you saw a page saying 'It Worked!' (or something similar indicating that Apache has been installed) on your screen or a Web site you visited, please go back and READ the page. It should explain what is going on. The page is the equivalent of a demo or the ReadMe file from a Windows application installation; it is intended for the person who installed the software and is supposed to show that the installation was completed successfully. The problem you are experiencing has nothing to do with us, and we cannot help you. You need to contact the Webmaster for the site. If the site is www.foo.com, for instance, try sending mail to <email address hidden>. If it's www.toddsbeer.org, send mail to <email address hidden>. And so on.
Some older versions of the 'It Worked!' page (supplied with older versions of the software) don't say that, or are mysterious or ambiguous. What they should say, and what the recent versions say, is something like this!
   "It Worked! The Apache Web Server is Installed on this Web
   Site!

   "If you can see this page, then the people who own this
   domain have just installed the Apache Web server software
   successfully. They now have to add content to this directory
   and replace this placeholder page, or else point the server
   at their real content.
   ---
   "If you are seeing this page instead of the site you expected,
   please contact the administrator of the site involved. (Try
   sending mail to <Webmaster@domain>.) Although this site is
   running the Apache software it almost certainly has no other
   connection to the Apache Group, so please do not send mail
   about this site or its contents to the Apache authors. If you
   do, your message will be ignored.
   ---"
 --End Quote--

This is also a good place to insert some good exposure for Ubuntu by inserting a banner ad linking back to Ubuntu.

Loye Young
http://www.iycc.biz
Laredo, Texas

Revision history for this message
Tollef Fog Heen (tfheen) wrote :

* Loye Young

| This is also a good place to insert some good exposure for Ubuntu by
| inserting a banner ad linking back to Ubuntu.

Yes, this is a nice theory. In practice, it means you will get mail
from angry users that you have hacked their web site, etc. We tried
it in Debian, and we did get those kinds of mails for quite a while.

I would rather recommend keeping the «It works» page.

--
Tollef Fog Heen
UNIX is user friendly, it's just picky about who its friends are

Revision history for this message
Owen (owen-boyle) wrote :

I know to any reasonably same person this text is perfectly obvious, but there will always be someone who sees that page and thinks "their" website has been hi-jacked. You can write what you like but you can't force people to read it, still less understand it.

If you do decide to change it, by all means put an Ubuntu banner on it... then they'll think it's Ubuntu that hi-jacked the site and *they'll* get all the flame-mail ;-)

Revision history for this message
Noah Slater (nslater) wrote :

How about something less unhelpful, like "Default site."

Revision history for this message
Christoph Langner (chrissss) wrote :

I would also vote for a more detailed default page. Just take a look at the lighttpd server. They've got a pretty neat placeholder page

http://img6.myimg.de/lighttpdd5238.png

I don't think someone who just installed lighty gets confused by this page...

Revision history for this message
Owen (owen-boyle) wrote :

Hi Christoph,

The problem is not about the installer - it's about his customer... Usually, the "it works" page is left up by the ISP that owns the server hardware. The customer, who owns the domain, comes along and thinks apache has hijacked his site. Hence he flames apache...

The point is that you are not writing for developers. You are writing for technically incompetent web-site owners.

Revision history for this message
Jim Tarvid (tarvid) wrote :

On 8/27/07, Owen <email address hidden> wrote:
> Hi Christoph,
>
> The problem is not about the installer - it's about his customer...
> Usually, the "it works" page is left up by the ISP that owns the server
> hardware. The customer, who owns the domain, comes along and thinks
> apache has hijacked his site. Hence he flames apache...
>
> The point is that you are not writing for developers. You are writing
> for technically incompetent web-site owners.
>
> --
> Apache2 default site contains only the words "It works!"
> https://bugs.launchpad.net/bugs/89364
> You received this bug notification because you are a member of Ubuntu
> Server Team, which is a bug contact for apache2 in ubuntu.
>
There are so many issues in running a shared web server that the
default web page falls into insignificance. Users sharing a web server
need user space and an apache stanza to point to that web space.
Operators of a shared web server have many choices all of them "bad".

Most of the "bad" choices involve management of apache, dns, mail,
database and choose to do so with a "virtual" environment. Trying to
mitigate the difficulty of managing accounts in a shared environment
is a noble and difficult task.

Most users of shared servers will have one of more domains they want
served. Fail over requires control of DNS. Thus for each user, for
each domain, he will need a DNS zone and an apache stanza.

I have despaired of any workable solution in providing incoming mail
service for those domains and have outsourced all of that to Google.
Running a mail server in today's environment is a career not a
project.

The database issue is most easily handled by creating per user
databases in MySQL. Easy to arrange for "real" users, less so for
"virtual" users. The most nagging consequence is that users will have
to leave database passwords lying around in clear text. Without some
sort of UID/GID scheme all users have access to each other's
passwords.

So by all means, a checklist of the work to be done in setting up
apache virtual servers would not be a bad thing. Implying that is all
that is required would be would be.

Jim Tarvid

Mathias Gug (mathiaz)
Changed in apache2:
status: Confirmed → Triaged
Revision history for this message
Alec Wright (alecjw) wrote :

My idea for "it works" page replacement:
The replacement page should have the ubuntu theme and should say something along the lines of "congratulations, your apache2 web server is working! for more information and help visit (link to somewhere on help.ubuntu.com). If you want to remove this page, simply delete the files: (list here) in your web directory"

Revision history for this message
Soren Hansen (soren) wrote : Re: [Bug 89364] Re: Apache2 default site contains only the words "It works!"

On Tue, Sep 16, 2008 at 04:11:03PM -0000, Alec Wright wrote:
> My idea for "it works" page replacement:

> The replacement page should have the ubuntu theme and should say
> something along the lines of "congratulations, your apache2 web server
> is working! for more information and help visit (link to somewhere on
> help.ubuntu.com). If you want to remove this page, simply delete the
> files: (list here) in your web directory"

This is not going to happen.

That page used to have a standard text that explained that the user has
correctly set up their Apache server and a bit of text about what the
Apache project was. This was changed to the simple "It works" page,
because it used to cause bug reports, e-mail threats, etc. etc. from
people who had failed to set up their server correctly, saw something
about "Apache" (without really reading the text of it) and drew the
conclusion that some "Apache" group had hacked their server, with which
they then went on to convey their dissatisfaction in less than
constructive ways.

Revision history for this message
Dustin Kirkland  (kirkland) wrote :

Marking "Won't Fix", per Soren's comments.

:-Dustin

Changed in apache2:
status: Triaged → Won't Fix
Revision history for this message
Loye Young (loyeyoung) wrote : Re: [Bug 89364] Re: Apache2 default site contains only the words "It works!"

There must be some middle ground. Perhaps something like:

<quote>

IT WORKS!

This is the default web page for this server.

The fact that you see this page means that the host computer is booted up,
the web server software is running, and the networking between your computer
and the host computer is functioning properly.

If this page is not what you expected, there are many possible causes. Check
with the owner or administrator of the server for more information.

</quote>

Revision history for this message
Soren Hansen (soren) wrote : Re: [Bug 89364] Re: Apache2 default site contains only the words "It works!"

On Thu, Sep 25, 2008 at 09:02:00PM -0000, Loye Young wrote:
> <quote>
>
> IT WORKS!
>
> This is the default web page for this server.
>
> The fact that you see this page means that the host computer is booted up,
> the web server software is running, and the networking between your computer
> and the host computer is functioning properly.
>
> If this page is not what you expected, there are many possible causes. Check
> with the owner or administrator of the server for more information.
>
> </quote>

Hm... I kind of like that, actually :)

Does anyone feel like forwarding this suggestion to Debian?

Revision history for this message
Noah Slater (nslater) wrote :

How about forwarding to Apache, where the bug is still WONTFIX.

On Fri, Sep 26, 2008 at 11:36:09AM -0000, Soren Hansen wrote:
> On Thu, Sep 25, 2008 at 09:02:00PM -0000, Loye Young wrote:
> > <quote>
> >
> > IT WORKS!
> >
> > This is the default web page for this server.
> >
> > The fact that you see this page means that the host computer is booted up,
> > the web server software is running, and the networking between your computer
> > and the host computer is functioning properly.
> >
> > If this page is not what you expected, there are many possible causes. Check
> > with the owner or administrator of the server for more information.
> >
> > </quote>
>
> Hm... I kind of like that, actually :)
>
> Does anyone feel like forwarding this suggestion to Debian?
>

--
Noah Slater, http://bytesexual.org/nslater

Revision history for this message
Soren Hansen (soren) wrote :

On Fri, Sep 26, 2008 at 11:56:39AM -0000, Noah Slater wrote:
>> Does anyone feel like forwarding this suggestion to Debian?
> How about forwarding to Apache, where the bug is still WONTFIX.

Even better.

Revision history for this message
Nate Theis (nate-techboy128) wrote :

How about this simple text?
"Your server has been correctly set up. You may now begin to upload your website."

Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package apache2 - 2.2.11-7ubuntu1

---------------
apache2 (2.2.11-7ubuntu1) karmic; urgency=low

  * Merge from debian unstable, remaining changes: LP: #398130
    - debian/patches/203_fix-ssl-timeftm-ignored.dpatch:
      Fix timefmt is ignored when XBitHack is on. (LP: #258914)
    - debian/{control,rules}: enable PIE hardening.
    - debian/{control, rules, apache2.2-common.ufw.profile}: add ufw profiles.

apache2 (2.2.11-7) unstable; urgency=low

  * Security fixes:
    - CVE-2009-1890: denial of service in mod_proxy
    - CVE-2009-1891: denial of service in mod_deflate (closes: #534712)
  * Add symlinks for the debug info to the mpm packages.
  * Be slightly more informative in the default index.html without pointing
    to Apache or Debian (LP: #89364)
  * Remove dependency on net-tools, which is no longer necessary
    (closes: #535849)
  * Bump Standards-Version (no changes)

 -- Bhavani Shankar <email address hidden> Sat, 11 Jul 2009 16:34:32 +0530

Changed in apache2 (Ubuntu):
status: Won't Fix → Fix Released
To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Other bug subscribers

Bug attachments